Bug 1397181 - [Regression] [Wayland] Toolbars go missing or get messed up after drag&drop
Summary: [Regression] [Wayland] Toolbars go missing or get messed up after drag&drop
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: libreoffice
Version: 25
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Caolan McNamara
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: WaylandRelated
TreeView+ depends on / blocked
 
Reported: 2016-11-21 19:54 UTC by Christian Stadelmann
Modified: 2016-11-26 22:53 UTC (History)
6 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2016-11-26 22:53:35 UTC


Attachments (Terms of Use)
A sample screencast showning the problem described in comment #0. (857.45 KB, application/octet-stream)
2016-11-22 10:46 UTC, Christian Stadelmann
no flags Details
bug demonstration video (568.55 KB, application/octet-stream)
2016-11-22 12:19 UTC, Kamil Páral
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Bugzilla 1391418 None None None Never

Internal Trackers: 1391418

Description Christian Stadelmann 2016-11-21 19:54:30 UTC
Description of problem:
After a patch for #1391418 disallowed detaching toolbars, they get messed up if dropped to a position where they can't be attached.

Version-Release number of selected component (if applicable):
libreoffice-5.2.3.3-6.fc25.x86_64
libreoffice-5.2.3.3-7.fc25.x86_64

How reproducible:
Always reproducible with 5.2.3.3-6 and 5.2.3.3-7 if running on wayland.
Never reproducible with 5.2.2.1-5 and 5.2.3.3-4, both of them have bug #1391418 instead.

Steps to Reproduce:
1. open any Libreoffice component (e.g. writer)
2. drag any toolbar
3. drop it into the text pane (where it would detach before the latest update)

Actual behavior:
While dragging the toolbar shadow indicates that the toolbar will be detached.
After releasing the mouse button, the toolbar is either gone completely or is drawn behind other toolbars or the main content (text or cells or drawing area on Writer / Calc / Draw).

Expected behavior:
Allow detaching toolbars.
Don't draw a shadow if the toolbar won't be there after drop.
If the toolbar cannot be shown where it was dropped, snap back to its original position but don't put it to some random position.

Additional info:
This bug was reported as https://bugzilla.redhat.com/show_bug.cgi?id=1391418#c7 first, but caolanm told me to file a separate bug.

I'd like to contribute a screencast but I can't get it working, see https://lists.fedoraproject.org/archives/list/desktop@lists.fedoraproject.org/thread/S37KBMW5A6RX5X2UXKG7XB45BFLAEBRK/ and https://bugzilla.redhat.com/show_bug.cgi?id=1391418#c10

Comment 1 Caolan McNamara 2016-11-22 09:08:00 UTC
"allow detaching toolbars", is not going to happen as far as I can see. Wayland is just a disaster for the detachable but dockable toolbar concept, gtk itself has deprecated its own GtkHandleBox and removed its own tearable menus and anything similar so the support just isn't there in the toolkit and as far as I can tell (and I've tried quite a few things) there's no reasonable way currently to do what we want.

things should definitely just snap back to where they came from though.

Comment 2 Christian Stadelmann 2016-11-22 10:46 UTC
Created attachment 1222655 [details]
A sample screencast showning the problem described in comment #0.

Getting the toolbar to hide completely is not always working. Getting it into a broken state is fairly easy.

Additionally, adding new toolbars from the menu (view -> toolbars -> select any of them) doesn't always work. You often have to restart LibreOffice to make the toolbars appear again. This also is a regression from X11 or recent LibreOffice versions. It seems that toolbars which are detached by default or which were detached last time they were used are affected.

Steps to reproduce for this:
1. open an old LibreOffice version
2. detach any toolbar, remember the name and keep it detached
3. close the toolbar or hide it from view -> toolbars menu
4. update to newer LibreOffice version
5. open LibreOffice
6. add toolbar from view -> toolbars menu

What happens:
Toolbar isn't shown until you restart LibreOffice.

What should happen:
Toolbar should be shown when activated.

Comment 3 Kamil Páral 2016-11-22 12:19 UTC
Created attachment 1222702 [details]
bug demonstration video

I can reproduce the same thing in writer. The toolbars are not lost, just hidden behind each other, or behind the document, and can be restored. It happens when you try to move the toolbar, and the last docking position is vertical, and then you move it somewhere undockable and release it. It stays at the same position, but flips vertically, and thus gets hidden behind the content pane. When you try to move it back, it sometimes gets hidden behind a different toolbar. See the video.

Comment 4 Fedora Update System 2016-11-23 11:23:05 UTC
libreoffice-5.2.3.3-9.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-04ed64a2ee

Comment 5 Kamil Páral 2016-11-23 12:49:20 UTC
The toolbars look OK to me now, I can't mess them up anymore. What about you, Christian?

Comment 6 Fedora Update System 2016-11-25 09:41:39 UTC
libreoffice-5.2.3.3-9.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-04ed64a2ee

Comment 7 Christian Stadelmann 2016-11-25 15:28:57 UTC
Works fine now, thank you!

Comment 8 Fedora Update System 2016-11-26 22:53:35 UTC
libreoffice-5.2.3.3-9.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.